/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or
 * redistribute the software under the terms of the CeCILL license as
 * circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 * As a counterpart to the access to the source code and rights to copy, modify
 * and redistribute granted by the license, users are provided only with a
 * limited warranty and the software's author, the holder of the economic
 * rights, and the successive licensors have only limited liability. In this
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally,
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 9 juil. 2007 17:14:01

import java.math.BigDecimal;

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.carambole.server.controleurs.AccueilCtrl;
import org.cocktail.fwkcktldepense.server.factory.FactoryDepenseBudget;
import org.cocktail.fwkcktldepense.server.factory.FactoryDepensePapier;
import org.cocktail.fwkcktldepense.server.factory.FactoryEngagementBudget;
import org.cocktail.fwkcktldepense.server.finder.FinderCommande;
import org.cocktail.fwkcktldepense.server.finder.FinderDepenseBudget;
import org.cocktail.fwkcktldepense.server.finder.FinderDepensePapier;
import org.cocktail.fwkcktldepense.server.finder.FinderEngagementBudget;
import org.cocktail.fwkcktldepense.server.finder.FinderFournisseur;
import org.cocktail.fwkcktldepense.server.finder.FinderTypeApplication;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EODepenseBudget;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier.ELiquidationType;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementBudget;
import org.cocktail.fwkcktldepense.server.metier.EOExercice;
import org.cocktail.fwkcktldepense.server.metier.EOFournisseur;
import org.cocktail.fwkcktldepense.server.metier.EOTypeApplication;
import org.cocktail.fwkcktldepense.server.metier.EOUtilisateur;
import org.cocktail.fwkcktldepense.server.metier._ISourceCredit.ESourceCreditType;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSKeyValueCoding;
import com.webobjects.foundation.NSMutableDictionary;

import er.extensions.eof.ERXEC;

public class Accueil extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	public Number numCmde = null;
	public Number numCmdeALiquider = null;
	public Number numEng = null;
	public String numFact = null;

	// Item Exercice utilise dans le popup d'exercices
	public EOExercice unExercice = null;

	public Accueil(WOContext context) {
		super(context);
	}

	public void reset() {
		session.defaultEditingContext().revert();
		session.initEtat();
		numCmde = null;
		numCmdeALiquider = null;
		numEng = null;
		numFact = null;
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
		//		String message = session.getAlertMessage();
		//		if (message != null && message.equals("") == false) {
		//			String str = "<script language=\"javascript\" type=\"text/javascript\">\n";
		//			str += "alert(\"" + message + "\");\n";
		//			str += "</script>";
		//			res.appendContentString(str);
		//			session.setAlertMessage(null);
		//		}
	}

	public boolean isPopupExercicesDisabled() {
		boolean isPopupExercicesDisabled = true;
		if (session.accueilControleur().exercices().count() > 1) {
			isPopupExercicesDisabled = false;
		}
		return isPopupExercicesDisabled;
	}

	public boolean isUtilisateurAvecDroitLiquider() {
		boolean isUtilisateurAvecDroitLiquider = false;
		EOUtilisateur utilisateur = utilisateur();

		if (utilisateur != null && utilisateur.isDroitLiquider(exerciceCourant())) {
			isUtilisateurAvecDroitLiquider = true;
		}

		return isUtilisateurAvecDroitLiquider;
	}

	public boolean isUtilisateurAvecDroitCreerDossiersLiquidation() {
		boolean isUtilisateurAvecDroitCreerDossiersLiquidation = false;
		EOUtilisateur utilisateur = utilisateur();

		if (utilisateur != null && utilisateur.isDroitCreerDossiersLiquidation(exerciceCourant())) {
			isUtilisateurAvecDroitCreerDossiersLiquidation = true;
		}

		return isUtilisateurAvecDroitCreerDossiersLiquidation;
	}

	public boolean isUtilisateurAvecDroitLiquidationExtourne() {
		AccueilCtrl ctrl = session.accueilControleur();
		return session.isLiquidationSurExtourneDisponible()
				&& (ctrl.getDroitLiquidationSansEngagegement() || ctrl.getDroitLiquidationSurEnveloppeExtourne() || ctrl.getDroitLiquidationSurMandatExtourne());
	}

	@SuppressWarnings("unchecked")
	public WOComponent changerExerciceCourant() {
		// on reinitialise le formatter de monnaie
		// en cas de chgt de monnaie entre des exercices distincts
		AccueilCtrl ctrl = session.accueilControleur();
		session.initMonnaieFormatter();
		ctrl.dgPreCommandes.queryBindings().setObjectForKey(ctrl.getExerciceCourant(), EOCommande.EXERCICE_KEY);
		ctrl.dgPreLiquidations.queryBindings().setObjectForKey(ctrl.getExerciceCourant(), EOCommande.EXERCICE_KEY);
		ctrl.dgLiquidationsAttente.queryBindings().setObjectForKey(ctrl.getExerciceCourant(), EOCommande.EXERCICE_KEY);
		ctrl.majDroits(utilisateur());
		return null;
	}

	public WOComponent creerCommande() {
		EOEditingContext nestedEdc = ERXEC.newEditingContext();
		session.setNestedEdc(nestedEdc);
		nestedEdc.setUndoManager(null);
		dgCommande().setSelectedObject(null);
		EOCommande laNouvelleCommande = session.getFactoryCommande().creer(nestedEdc);
		EOExercice exercice = exerciceCourant();
		session.setLaCommandeEnCours(laNouvelleCommande);

		return NavigationCtrl.goToBonDeCommande(context(), laNouvelleCommande, exercice, "Articles");
	}

	public WOComponent creerCommandeAvecFournisseur(EOFournisseur unFournisseur) {
		EOEditingContext nestedEdc = ERXEC.newEditingContext();
		session.setNestedEdc(nestedEdc);
		nestedEdc.setUndoManager(null);
		dgCommande().setSelectedObject(null);
		EOCommande laNouvelleCommande = session.getFactoryCommande().creer(nestedEdc);
		EOFournisseur fournisseur = FinderFournisseur.getFournisseur(nestedEdc, unFournisseur.fouCode());
		session.getFactoryCommande().affecterFournisseur(laNouvelleCommande, fournisseur);
		EOExercice exercice = exerciceCourant();
		session.setLaCommandeEnCours(laNouvelleCommande);

		return NavigationCtrl.goToBonDeCommande(context(), laNouvelleCommande, exercice, "Articles");
	}

	public WOComponent creerEngagement() {
		Engagement nextPage = (Engagement) pageWithName("Engagement");
		return nextPage;

	}

	public boolean isPossibleCreerUnePrestation() {
		boolean isPossibleCreerUnePrestation = false;
		if (utilisateur() != null) {
			isPossibleCreerUnePrestation = utilisateur().isDroitCreerPrestation(exerciceCourant());
		}
		return isPossibleCreerUnePrestation;
	}

	public WOComponent creerPrestationInterne() {
		EOEditingContext nestedEdc = ERXEC.newEditingContext();
		session.setNestedEdc(nestedEdc);
		nestedEdc.setUndoManager(null);
		dgCommande().setSelectedObject(null);
		EOCommande laNouvelleCommande = session.getFactoryCommande().creer(nestedEdc);
		laNouvelleCommande.setIsEnregistrerPI(true);
		EOExercice exercice = exerciceCourant();
		session.setLaCommandeEnCours(laNouvelleCommande);

		return NavigationCtrl.goToBonDeCommande(context(), laNouvelleCommande, exercice, "Articles");
	}

	public WOComponent afficherPrecommandes() {
		PreCommandeListe nextPage = (PreCommandeListe) pageWithName("PreCommandeListe");
		WODisplayGroup dgPC = dgPreCommande();
		WODisplayGroup dgC = dgCommande();
		@SuppressWarnings("unchecked")
		NSDictionary<String, Object> bdgs = dgPC.queryBindings();
		NSArray<NSDictionary<String, Object>> lesPrecommandes = FinderCommande.getRawRowPreCommandes(edc(), bdgs);
		dgPC.setObjectArray(lesPrecommandes);
		dgC.clearSelection();
		dgC.setObjectArray(null);
		nextPage.setDg(dgPC);

		return nextPage;
	}

	public WOComponent afficherLiquidationsExtourne() {
		LiquidationExtourneListe liquidationsExtourneListePage =
				(LiquidationExtourneListe) pageWithName(LiquidationExtourneListe.PAGE_NAME);
		liquidationsExtourneListePage.initPage();
		return liquidationsExtourneListePage;
	}

	public long getNbreLiquidationsExtourneALiquider() {
		return FinderDepenseBudget.instance().countLiquidationsExtourneNonSoldees(edc(), exerciceCourant(), utilisateur());
	}

	public boolean existsLiquidationsExtourneALiquider() {
		return getNbreLiquidationsExtourneALiquider() > 0L;
	}

	public WOComponent afficherPreliquidations() {
		PreLiquidationsListePage nextPage = (PreLiquidationsListePage) pageWithName(PreLiquidationsListePage.class.getName());
		WODisplayGroup dgPC = dgPreLiquidation();
		@SuppressWarnings("unchecked")
		NSDictionary<String, Object> bdgs = dgPC.queryBindings();
		NSArray<NSDictionary<String, Object>> lesLiquidations = FinderDepensePapier.getRawRowPreLiquidation(edc(), bdgs);
		dgPC.setObjectArray(lesLiquidations);
		nextPage.setDg(dgPC);
		return nextPage;
	}

	//
	//	public WOComponent afficherLiquidations() {
	//		LiquidationsDossierCreation nextPage = (LiquidationsDossierCreation) pageWithName(LiquidationsDossierCreation.class.getName());
	//		//		WODisplayGroup dgPC = dgPreLiquidation();
	//		//		//WODisplayGroup dgC = dgCommande();
	//		//		NSDictionary bdgs = dgPC.queryBindings();
	//		//		NSArray lesLiquidations = FinderDepensePapier.getRawRowPreLiquidation(edc(), bdgs);
	//		//		dgPC.setObjectArray(lesLiquidations);
	//		//		//		dgC.clearSelection();
	//		//		//		dgC.setObjectArray(null);
	//		//		nextPage.setDg(dgPC);
	//
	//		return nextPage;
	//	}

	public WOComponent rechercherUneCommande() {
		WOComponent nextPage = null;
		Number numero = getNumCmde();
		if (numero != null) {
			// Pour etre sur de recuperer une commande a jour
			// on fetche dans un nouvel edc
			EOEditingContext newEdc = ERXEC.newEditingContext();
			EOExercice exercice = exerciceCourant();
			EOCommande commande = FinderCommande.getCommande(newEdc, exercice, numero);
			if (commande != null) {
				if (commande.isConsultable(newEdc, utilisateurInContext(newEdc))) {
					nextPage = (DetailCommande) pageWithName("DetailCommande");
					((DetailCommande) nextPage).setLaCommande(commande);
					session.setLaCommandeEnCours(commande);
					session.setNestedEdc(newEdc);
				} else {
					session.setAlertMessage("Vous n'avez pas les autorisations suffisantes \n pour consulter cette commande.");
				}
			} else {
				session.setAlertMessage("Il n'existe aucune commande avec ce numéro.");
			}
		}

		return nextPage;
	}

	public WOComponent rechercherCommandes() {
		CommandeListe nextPage = (CommandeListe) pageWithName(CommandeListe.class.getName());
		// EOExercice exercice = FinderExercice.getExercicePourDate(edc(), new NSTimestamp());
		session.accueilControleur().initialize(utilisateurInContext(edc()), exerciceCourant(), session.sessionID());
		WODisplayGroup dg = dgCommande();
		WODisplayGroup dgPC = dgPreCommande();
		dgPC.clearSelection();
		dgPC.setObjectArray(null);
		dg.setObjectArray(null);
		nextPage.setDg(dg);
		return nextPage;
	}

	public WOComponent rechercherUnEngagement() {
		WOComponent nextPage = null;
		Number numero = getNumEng();
		if (numero != null) {
			EOEditingContext newEdc = ERXEC.newEditingContext();
			// EOExercice exercice = FinderExercice.getExercicePourDate(newEdc, new NSTimestamp());
			EOEngagementBudget engagementBudget = FinderEngagementBudget.getEngagementBudget(newEdc, exerciceCourant(), numero);
			if (engagementBudget != null) {
				if (engagementBudget.isConsultable(newEdc, utilisateurInContext(newEdc), null)) {
					nextPage = (DetailEngagementBudget) pageWithName("DetailEngagementBudget");
					((DetailEngagementBudget) nextPage).setEngagementBudget(engagementBudget);
					session.setNestedEdc(newEdc);
					session.setLEngagementBudgetEnCours(engagementBudget);
				} else {
					session.setAlertMessage("Vous n'avez pas les autorisations suffisantes \n pour consulter cet engagement.");
				}
			} else {
				session.setAlertMessage("Ce numéro d'engagement n'existe pas.");
			}
		}

		return nextPage;
	}

	public WOComponent rechercherEngagements() {
		EngagementListe nextPage = (EngagementListe) pageWithName("EngagementListe");
		//EOExercice exercice = FinderExercice.getExercicePourDate(edc(), new NSTimestamp());
		session.accueilControleur().initialize(utilisateurInContext(edc()), exerciceCourant(), session.sessionID());
		WODisplayGroup dg = dgEngagement();
		dg.setObjectArray(null);
		nextPage.setDg(dg);
		return nextPage;
	}

	public WOComponent liquiderUneCommande() {
		Liquidation2 nextPage = null;
		Number numero = getNumCmdeALiquider();
		if (numero != null) {
			EOEditingContext newEdc = ERXEC.newEditingContext();
			// EOExercice exercice = FinderExercice.getExercicePourDate(newEdc, new NSTimestamp());
			EOCommande commande = FinderCommande.getCommande(newEdc, exerciceCourant(), numero);
			if (commande != null) {
				if (commande.isLiquidable(newEdc, utilisateurInContext(newEdc), null)) {
					session.setLaCommandeEnCours(commande);
					nextPage = (Liquidation2) pageWithName(Liquidation2.class.getName());
					FactoryDepensePapier fdp = new FactoryDepensePapier();
					EODepensePapier laDepensePapier = fdp.creer(newEdc, BigDecimal.valueOf(0), BigDecimal.valueOf(0), BigDecimal.valueOf(0), null, null, null, null, commande.exercice(), utilisateurInContext(newEdc), null, null, commande.fournisseur(), commande);
					if (session.isServiceFacturierDisponible().booleanValue()) {
						fdp.creerPreDepensesBudget(newEdc, laDepensePapier);
					} else {
						fdp.creerDepensesBudget(newEdc, laDepensePapier);
					}
					laDepensePapier.setLiquidationType(ELiquidationType.SUR_COMMANDE);
					nextPage = NavigationCtrl.goToLiquidation(context(), laDepensePapier);

					//session.setLaDepensePapierEnCours(laDepensePapier);
					// session.setItemsMenu(Liquidation.itemsMenu());
					session.setNestedEdc(newEdc);

					//nextPage.setLaDepensePapier(laDepensePapier);
				} else {
					session.setAlertMessage("Vous ne pouvez pas liquider cette commande.");
				}
			} else {
				session.setAlertMessage("Ce numéro de commande n'existe pas.");
			}
		}

		return nextPage;
	}

	public WOComponent rechercherUneFacture() {
		WOComponent nextPage = null;
		String numero = getNumFact();
		if (numero != null) {
			EOEditingContext newEdc = ERXEC.newEditingContext();
			// EOExercice exercice = session.exerciceCourant();
			NSMutableDictionary<String, Object> bdgs = new NSMutableDictionary<String, Object>();
			bdgs.setObjectForKey(exerciceCourant(), "exercice");
			bdgs.setObjectForKey(numero, "dppNumeroFacture");
			bdgs.setObjectForKey(utilisateur(), "utilisateur");
			NSArray<? extends NSKeyValueCoding> lesFactures = null;
			int nbFactures = FinderDepensePapier.getRawRowCountDepensePapierPourNumeroFacture(edc(), bdgs);
			if (nbFactures > 1 && nbFactures <= 500) {
				lesFactures = FinderDepensePapier.getRawRowDepensePapierPourNumeroFacture(edc(), bdgs);
				session.setAlertMessage(null);
				nextPage = (FactureListe) pageWithName("FactureListe");
				WODisplayGroup dg = dgFacture();
				dg.setObjectArray(lesFactures);
				((FactureListe) nextPage).setDg(dg);
			} else {
				lesFactures = null;
				if (nbFactures == 1) {
					bdgs.setObjectForKey("*" + numero + "*", "dppNumeroFacture");
					lesFactures = FinderDepensePapier.getDepensePapierPourNumeroFacture(newEdc, bdgs);
					EODepensePapier facture = (EODepensePapier) lesFactures.lastObject();
					EOCommande commande = facture.commandeassociee();
					nextPage = (DetailFacture) pageWithName("DetailFacture");
					((DetailFacture) nextPage).setLaFacture(facture);
					session.setAlertMessage(null);
					session.setLaDepensePapierEnCours(facture);
					session.setLaCommandeEnCours(commande);
					session.setNestedEdc(newEdc);
				} else if (nbFactures > 500) {
					session.setAlertMessage(nbFactures + " factures trouvées. Veuillez affiner la recherche.");
				} else {
					session.setAlertMessage("Il n'existe aucune facture avec ce numéro.");
				}
			}
		}

		return nextPage;
	}

	public WOComponent rechercherFactures() {
		FactureListe nextPage = (FactureListe) pageWithName("FactureListe");
		// EOExercice exercice = session.exerciceCourant();
		session.accueilControleur().initialize(utilisateurInContext(edc()), exerciceCourant(), session.sessionID());
		WODisplayGroup dg = dgFacture();
		dg.setObjectArray(null);
		nextPage.setDg(dg);
		return nextPage;
	}

	public WOComponent rechercherDossiersLiquidation() {
		LiquidationsDossierSuivi nextPage = (LiquidationsDossierSuivi) pageWithName(LiquidationsDossierSuivi.class.getName());
		nextPage.refreshData();
		//		NSArray bords = EOBordereau.fetchAllDossiersLiquidation(edc(), EOBordereau.QUAL_BOR_ETAT_VALIDE, new NSArray(new Object[] {
		//				EOBordereau.SORT_GES_CODE, EOBordereau.SORT_BOR_NUM_DESC
		//		}));
		//		nextPage.refreshDepenses();
		return nextPage;
	}

	public WOComponent realiserLiquidationSansEngagement() {

		setLaCommandeEnCours(null);
		EOExercice exercice = exerciceCourant();
		EOUtilisateur utilisateur = utilisateurInContext(edc());
		FactoryDepensePapier fdp = new FactoryDepensePapier();
		EODepensePapier dpp = fdp.creer(edc());
		dpp.setExerciceRelationship(exercice);
		dpp.setUtilisateurRelationship(utilisateur);
		dpp.setLiquidationType(ELiquidationType.SANS_ENGAGEMENT);

		FactoryEngagementBudget factoryEngagementBudget = new FactoryEngagementBudget();

		EOTypeApplication typeApplication = FinderTypeApplication.getTypeApplication(edc(), EOTypeApplication.APPLICATION_DEPENSE_FRAMEWORK);
		EOEngagementBudget engagementBudget = factoryEngagementBudget.creer(edc());
		engagementBudget.setEngHtSaisie(BigDecimal.ZERO);
		engagementBudget.setEngTtcSaisie(BigDecimal.ZERO);
		engagementBudget.setEngMontantBudgetaire(BigDecimal.ZERO);
		engagementBudget.setEngMontantBudgetaireReste(BigDecimal.ZERO);
		engagementBudget.setTypeApplicationRelationship(typeApplication);
		engagementBudget.setExerciceRelationship(exercice);
		engagementBudget.setUtilisateurRelationship(utilisateur);
		FactoryDepenseBudget fdb = new FactoryDepenseBudget();
		EODepenseBudget depenseBudget = fdb.creer(edc(), BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, dpp,
				engagementBudget, engagementBudget.tauxProrata(), engagementBudget.exercice(), utilisateur, ESourceCreditType.BUDGET, null);

		return NavigationCtrl.goToLiquidationSansEngagement(context(), dpp);
	}

	public WOComponent realiserLiquidationSurExtourneEnveloppe() {
		setLaCommandeEnCours(null);
		EOExercice exercice = exerciceCourant();
		EOUtilisateur utilisateur = utilisateurInContext(edc());
		FactoryDepensePapier fdp = new FactoryDepensePapier();
		EODepensePapier dpp = fdp.creer(edc());
		dpp.setExerciceRelationship(exercice);
		dpp.setUtilisateurRelationship(utilisateur);
		dpp.setLiquidationType(ELiquidationType.SUR_EXTOURNE_ENVELOPPE);

		FactoryEngagementBudget factoryEngagementBudget = new FactoryEngagementBudget();

		EOTypeApplication typeApplication = FinderTypeApplication.getTypeApplication(edc(), EOTypeApplication.APPLICATION_DEPENSE_FRAMEWORK);
		//		EOEngagementBudget engagementBudget = factoryEngagementBudget.creer(edc(), null, BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, null, null, null, typeApplication, null, exercice, utilisateur);
		EOEngagementBudget engagementBudget = factoryEngagementBudget.creer(edc());
		engagementBudget.setEngHtSaisie(BigDecimal.ZERO);
		engagementBudget.setEngTtcSaisie(BigDecimal.ZERO);
		engagementBudget.setEngMontantBudgetaire(BigDecimal.ZERO);
		engagementBudget.setEngMontantBudgetaireReste(BigDecimal.ZERO);
		engagementBudget.setTypeApplicationRelationship(typeApplication);
		engagementBudget.setExerciceRelationship(exercice);
		engagementBudget.setUtilisateurRelationship(utilisateur);
		FactoryDepenseBudget fdb = new FactoryDepenseBudget();
		EODepenseBudget depenseBudget = fdb.creer(edc(), BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, BigDecimal.ZERO, dpp,
				engagementBudget, engagementBudget.tauxProrata(), engagementBudget.exercice(), utilisateur, ESourceCreditType.EXTOURNE, null);
		//depenseBudget.setSourceTypeCredit(ESourceCreditType.EXTOURNE);

		return NavigationCtrl.goToLiquidationSurExtourneEnveloppe(context(), dpp);
	}

	public WOComponent visualiserCommandesBasculees() {
		CommandesBasculeesListe nextPage = (CommandesBasculeesListe) pageWithName("CommandesBasculeesListe");

		return nextPage;
	}

	public WOComponent gestionDossierLiquidation() {
		LiquidationsDossierCreation nextPage = (LiquidationsDossierCreation) pageWithName(LiquidationsDossierCreation.class.getName());
		nextPage.refreshData();
		return nextPage;
	}

	public WOComponent creerUnFournisseur() {
		FournisseurPage nextPage = (FournisseurPage) pageWithName(FournisseurPage.class.getName());
		session.defaultEditingContext().revert();
		nextPage.setResetSrchForm(Boolean.TRUE);

		return nextPage;
	}

	public WOComponent gestionCodeAnalytique() {
		CodeAnalytiquePage nextPage = (CodeAnalytiquePage) pageWithName(CodeAnalytiquePage.class.getName());
		return nextPage;
	}

	@SuppressWarnings("unchecked")
	public int getNbrePrecommandes() {
		int nbre = 0;
		if (session.accueilControleur() != null) {
			nbre = FinderCommande.getRawRowCountPreCommandes(edc(), session.accueilControleur().dgPreCommandes.queryBindings());
		}
		return nbre;
	}

	@SuppressWarnings("unchecked")
	public int getNbrePreliquidations() {
		int nbre = 0;
		if (session.accueilControleur() != null) {
			nbre = FinderDepensePapier.getRawRowCountPreLiquidation(edc(), session.accueilControleur().dgPreLiquidations.queryBindings());
		}
		return nbre;
	}

	@SuppressWarnings("unchecked")
	public int nbreLiquidations() {
		int nbre = 0;
		if (session.accueilControleur() != null) {
			nbre = FinderDepensePapier.getRawRowCountLiquidationsPourDossier(edc(), session.accueilControleur().dgLiquidationsAttente.queryBindings());
		}
		return nbre;
	}

	public AccueilCtrl controller() {
		return session.accueilControleur();
	}

	public Number getNumEng() {
		return numEng;
	}

	public void setNumEng(Number numEng) {
		this.numEng = numEng;
	}

	public String getNumFact() {
		return numFact;
	}

	public void setNumFact(String numFact) {
		this.numFact = numFact;
	}

	public Number getNumCmde() {
		return numCmde;
	}

	public void setNumCmde(Number numCmde) {
		this.numCmde = numCmde;
	}

	public Number getNumCmdeALiquider() {
		return numCmdeALiquider;
	}

	public void setNumCmdeALiquider(Number numCmdeALiquider) {
		this.numCmdeALiquider = numCmdeALiquider;
	}

}